#!/bin/sh

echo "Compilation de libpixlib.so"
cd libpixlib/src
gcc -Wall -fPIC -c pixlib.c -I..

gcc -Wall -fPIC -c fileformats/bmp.c -I..
gcc -Wall -fPIC -c fileformats/raw.c -I..
gcc -Wall -fPIC -c fileformats/tga.c -I..
gcc -Wall -fPIC -c fileformats/png.c -I..
gcc -Wall -fPIC -c fileformats/jpg.c -I..
gcc -Wall -fPIC -c fileformats/webp.c -I..
gcc -Wall -fPIC -c fileformats/pgm.c -I..

gcc -Wall -fPIC -c Effets/couleurs.c -I..
gcc -Wall -fPIC -c Effets/disposition.c -I..
gcc -Wall -fPIC -c Effets/blit.c -I..
gcc -Wall -fPIC -c Effets/font.c -I..
gcc -Wall -fPIC -c Effets/draw.c -I..

#gcc -shared -Wl,-soname,pixlib.so.1 -o libpixlib.so.1.0.1  pixlib.o bitmap.o raw.o tga.o font.o draw.o disposition.o couleurs.o blit.o -lm
#gcc -shared -o libpixlib.so pixlib.o bitmap.o png.o jpg.o raw.o tga.o font.o draw.o disposition.o couleurs.o blit.o -lm -lpng -ljpeg
gcc -shared -o ../libpixlib.so *.o -lm -lpng -ljpeg
rm *.o

echo "Compile et lance deux exemples d'exécutables qui emploient libpixlib.so: degrade et detourage"
cd ..
gcc -Wall -s -o ../degrade exemples/degrade.c -I. -L. -lpixlib
cd ..
./degrade

cd libpixlib
gcc -Wall -s -o ../detourage exemples/detourage.c -I. -L. -lpixlib
cd ..
./detourage

echo "Compile l'interpréteur c'est l'exe pixlib"
gcc -Wall -s -o pixlib interpreteur.c -I./libpixlib -L./libpixlib -lpixlib -I./libtcc -L./libtcc -ltcc -ldl

echo "Lance un script pour tester l'interpréteur"
./pixlib scripts/creer-image.c

