// Programme de test qui appelle des fonctions de libpixlib.so
// Crée un dégradé (gradient) du vert au rouge, image 1X255 pixels à étirer pour le web

// $ gcc -Wall -s -o degrade degrade.c -I./libpixlib -L./libpixlib -lpixlib
// $ export LD_LIBRARY_PATH=/home/masta/pixlib2021/libpixlib:$LD_LIBRARY_PATH
// ./degrade

// Exactement le même code que l'exemple interprété scripts/couleurs/degrade.c

#include <pixlib.h>

int main()
{
	PIX *img;
	int y;
	unsigned char *p;

	img = pix_create(1,255, 3);
	if (!img) return 1;
  
	RGBpixel a = {106,117,78};  // vert olive
	RGBpixel b = {255,  0, 0};  // rouge

	float rdiff = (float)(b.r - a.r)/255.f;
	float gdiff = (float)(b.g - a.g)/255.f;
	float bdiff = (float)(b.b - a.b)/255.f;

	//printf("diff:%.3f %.3f %.3f\n", rdiff, gdiff, bdiff);

	for(y=0; y < img->height; y++)
	{
		p = img->pixels + (y * img->width) * img->nchannels;   
		p[0] = b.r - (unsigned char)(y*rdiff);
		p[1] = b.g - (unsigned char)(y*gdiff);
		p[2] = b.b - (unsigned char)(y*bdiff);
	}

	pix_save_png(img, "degrade.png");
	pix_destroy(img);
	return 0;
}

