/* ___ _      _ _ _     
  / _ (_)_  _| (_) |__  
 / /_)/ \ \/ / | | '_ \ 
/ ___/| |>  <| | | |_) |
\/    |_/_/\_\_|_|_.__/ */
#include <pixlib.h>
// $ sudo apt-cache search libpng
// $ sudo apt-get install libpng-dev
#include <png.h>
#include <stdlib.h>

// La dll win32 et le header proviennent de http://www.libpng.org/pub/png/libpng.html
//#include "../libpng/png.h"

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  Charger une image PNG du disque dans un PIX
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
PIX *pix_load_png (const char* filename)
{
  FILE *pF;
  unsigned char header[8]; // 8 is the maximum size that can be checked
  png_structp png_ptr;
  png_infop info_ptr;
  int width, height;
  PIX *img;
  int x, y;
  long a;
  png_byte color_type;
  //png_byte bit_depth;
  //int number_of_passes;
  png_bytep *row_pointers;
  png_byte *ptr;

  pF = fopen(filename, "rb");
  if (!pF) {printf("Fichier introuvable [%s]\n", filename); return NULL;}

  fread(header, 1, 8, pF);
  if (png_sig_cmp(header, 0, 8)) return NULL; // magic number pas png

  png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
  if (!png_ptr) return NULL;

  info_ptr = png_create_info_struct(png_ptr);
  if (!info_ptr) return NULL;

  if (setjmp(png_jmpbuf(png_ptr))) return NULL;

  png_init_io(png_ptr, pF);
  png_set_sig_bytes(png_ptr, 8);

  png_read_info(png_ptr, info_ptr);

  //width = info_ptr->width;
  //height = info_ptr->height;

        width = png_get_image_width(png_ptr, info_ptr);
        height = png_get_image_height(png_ptr, info_ptr);

  //color_type = info_ptr->color_type;
  color_type = png_get_color_type(png_ptr, info_ptr);
  //printf("color type: %d\nPNG_COLOR_TYPE_RGBA=%d", info_ptr->color_type, PNG_COLOR_TYPE_RGBA);

  //bit_depth = png_get_bit_depth(png_ptr, info_ptr);
  //bit_depth = info_ptr->bit_depth;
  //printf("bit_depth: %d\n", info_ptr->bit_depth);

  //number_of_passes = png_set_interlace_handling(png_ptr);
  png_read_update_info(png_ptr, info_ptr);

  // read file
  if (setjmp(png_jmpbuf(png_ptr))) return NULL;

  // revoir ça
  img = pix_create(width, height, 3);
       //(info_ptr->color_type == PNG_COLOR_TYPE_RGB_ALPHA)?4:3);
  //printf("%d channels\n", img->nchannels);

  row_pointers = (png_bytep*) malloc(sizeof(png_bytep) * img->height);
  for (y=0; y<img->height; y++)
		//row_pointers[y] = (png_byte*) malloc(info_ptr->rowbytes);
        row_pointers[y] = (png_byte*) malloc(png_get_rowbytes(png_ptr,info_ptr));

  png_read_image(png_ptr, row_pointers);

  if (color_type == PNG_COLOR_TYPE_RGBA)
  {
    for (y=0; y<img->height; y++)
    {
      for (x=0; x<img->width; x++)
      {
        ptr = &row_pointers[y][x*4];
        a = (x + ((img->height-y-1)*img->width))*img->nchannels;
        img->pixels[a+0]=ptr[0];
        img->pixels[a+1]=ptr[1];
        img->pixels[a+2]=ptr[2];
        //if (img->nchannels==4) img->pixels[a+3]=ptr[3]; // alpha!
      }
      free(row_pointers[y]);
    }
  }

  free(row_pointers);
  fclose(pF);
  return img;
}
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  Enregistrer un PIX dans une image PNG sur le disque
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
int pix_save_png(PIX *img, const char* filename)
{
  FILE *pF;
  png_structp png_ptr;
  png_infop info_ptr;
  int k;//, depth=3;
  png_bytep *row_pointers;

  // si filename contient un / vérifier si le dossier existe, si ce n'est pas le cas le signaler et retourner zéro.

  pF = fopen(filename, "wb");
  if (!pF) return 0;

  png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
  if (!png_ptr)
  {
    fclose(pF);
    return 0;
  }

  info_ptr = png_create_info_struct(png_ptr);
  if (!info_ptr)
  {
    fclose(pF);
    png_destroy_write_struct(&png_ptr,  (png_infopp)NULL);
    return 0;
  }

  if (setjmp(png_jmpbuf(png_ptr)))
  //if (setjmp(png_ptr->jmpbuf))
  {
    fclose(pF);
    png_destroy_write_struct(&png_ptr,  (png_infopp)NULL);
    return 0;
  }

  png_init_io(png_ptr, pF);
   /* Set the image information here.  Width and height are up to 2^31,
    * bit_depth is one of 1, 2, 4, 8, or 16, but valid values also depend on
    * the color_type selected. color_type is one of PNG_COLOR_TYPE_GRAY,
    * PNG_COLOR_TYPE_GRAY_ALPHA, PNG_COLOR_TYPE_PALETTE, PNG_COLOR_TYPE_RGB,
    * or PNG_COLOR_TYPE_RGB_ALPHA.  interlace is either PNG_INTERLACE_NONE or
    * PNG_INTERLACE_ADAM7, and the compression_type and filter_type MUST
    * currently be PNG_COMPRESSION_TYPE_BASE and PNG_FILTER_TYPE_BASE. REQUIRED
    */
  png_set_IHDR(png_ptr, info_ptr, img->width, img->height, 8,
               PNG_COLOR_TYPE_RGB,
               PNG_INTERLACE_NONE,
               PNG_COMPRESSION_TYPE_BASE,
               PNG_FILTER_TYPE_BASE);
/*
  switch (depth) {
		case 1:
		png_set_IHDR(png_ptr, info_ptr, width, height, 8, PNG_COLOR_TYPE_GRAY,\
			PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
		break;
		case 2:
		png_set_IHDR(png_ptr, info_ptr, width, height, 8, PNG_COLOR_TYPE_GRAY_ALPHA,\
			PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
		break;
		case 3:
		png_set_IHDR(png_ptr, info_ptr, width, height, 8, PNG_COLOR_TYPE_RGB,\
			PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
		break;
		case 4:
		png_set_IHDR(png_ptr, info_ptr, width, height, 8, PNG_COLOR_TYPE_RGB_ALPHA,\
			PNG_INTERLACE_NONE, PNG_COMPRESSION_TYPE_BASE, PNG_FILTER_TYPE_BASE);
		break;
		default:
			printf("Profondeur de couleur non supporté pour la sauvegarde en png.\n");
  }*/

  /* commentaires de l'image, facultatif
  png_text text[6];

  text[0].key = "Title";
  text[0].text = "";
  text[0].compression = PNG_TEXT_COMPRESSION_NONE;

  text[1].key = "Author";
  text[1].text = "";
  text[1].compression = PNG_TEXT_COMPRESSION_NONE;

  text[2].key = "Description";
  text[2].text = "";
  text[2].compression = PNG_TEXT_COMPRESSION_NONE;

  text[3].key = "Copyright";
  text[3].text = "";
  text[3].compression = PNG_TEXT_COMPRESSION_NONE;

  text[4].key = "E-mail";
  text[4].text = "";
  text[4].compression = PNG_TEXT_COMPRESSION_NONE;

  text[5].key = "Url";
  text[5].text = "";
  text[5].compression = PNG_TEXT_COMPRESSION_NONE;
  png_set_text(png_ptr, info_ptr, text, 6);*/
  
  png_write_info(png_ptr, info_ptr);

  row_pointers= (png_bytep *)malloc(sizeof(png_bytep) *img->height);
  pix_flip_vertical(img);
  for (k=0; k<img->height; k++)
  //for (k=img->height; k>-1; k--)
    row_pointers[k] = img->pixels + k*img->width*img->nchannels;

  // write pixels
  png_write_image(png_ptr, row_pointers);
  png_write_end(png_ptr, info_ptr);

  png_destroy_write_struct(&png_ptr, (png_infopp)NULL);
  fclose(pF);
  free (row_pointers);

  return 1;
}

