/*
$ sudo apt-get install libwepp-dev
fichiers installés:

/usr/include/webp/decode.h
/usr/include/webp/demux.h
/usr/include/webp/encode.h
/usr/include/webp/mux.h
/usr/include/webp/mux_types.h
/usr/include/webp/types.h

/usr/lib/x86_64-linux-gnu/libwebp.a
/usr/lib/x86_64-linux-gnu/libwebp.so
/usr/lib/x86_64-linux-gnu/libwebpdemux.a
/usr/lib/x86_64-linux-gnu/libwebpdemux.so
/usr/lib/x86_64-linux-gnu/libwebpmux.a
/usr/lib/x86_64-linux-gnu/libwebpmux.so

//#include <webp/decode.h>
//#include <webp/demux.h>
//#include <webp/encode.h>
//#include <webp/mux.h>
//#include <webp/types.h>

Trouver un exemple car l'API n'en a pas.
Plus simple:

$ sudo apt install webp
$ cwebp -q 50 -lossless picture.png -o picture_lossless.webp	→ 27.8Ko
$ cwebp -q 70 picture_with_alpha.png -o picture_with_alpha.webp
$ cwebp -sns 70 -f 50 -size 60000 picture.png -o picture.webp	→ 38Ko
$ cwebp picture.png -o picture.webp 							→ 15Ko

options
-lossless	sans perte
- q			qualité 0 à 100
- sns		spatial noise shaping
-size		target size
-f			filter
*/

#include <pixlib.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  Charger une image WEBP du disque dans un PIX
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%* /
PIX* pix_load_webp (const char *fic)
{
	char c[64];
	PIX *img;

	sprintf(c,"dwebp %s -o tmp.png", fic); // transforme le webp en png
	system(c);

	//sleep(1);

	img = pix_load_png("tmp.png"); // et charge le png en PIX*
	unlink("tmp.png");
	return img;
}
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  Enregistrer un PIX dans une image WEBP sur le disque
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
void pix_save_webp(PIX* img, const char* file)
{
	pix_save_png(img, "tmp.png");
	char c[64];
	sprintf(c,"cwebp -quiet tmp.png -o %s", file);
	system(c);
	unlink("tmp.png");
}
/*
int main(){

	//PIX* img = pix_load_webp("test.webp");
	//pix_save_png(img, "test.png");

	// écrit le PIX en .png
	PIX* img = pix_load_png("../../../img/1.png");
	//pix_sepia(img);
	pix_save_webp(img,"test.webp");

	return 0;
}
*/

